@use '../core/variables_scss' as v;

.-m {
  @mixin mv($size){
    margin-top: $size;
    margin-bottom: $size;
  }

  @mixin mh($size){
    margin-right: $size;
    margin-left: $size;
  }

  // Vertical margins
  &v {
    &0 { @include mv(0) }

    // -mvs/-mvd/...
    @each $alias, $size in v.$sizes {
      &#{$alias} { @include mv(var(--spacer-#{$size})) }
    }
  }

  // Horizontal margins
  &h {
    &0 { @include mh(0) }

    // -mvs/-mvd/...
    @each $alias, $size in v.$sizes {
      &#{$alias} { @include mh(var(--spacer-#{$size})) }
    }
  }

  // Side margins
  @each $side-alias, $side in v.$sides {
    &#{$side-alias}{
      &0{ margin-#{$side}: 0 }

      @each $size-alias, $size in v.$sizes {
        &#{$size-alias} { margin-#{$side}: var(--spacer-#{$size}) }
      }
    }
  }

  // All at once
  &0 { margin: 0; }

  @each $alias, $size in v.$sizes {
    &#{$alias} { margin: var(--spacer-#{$size}) }
  }
}
